/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import java.util.Calendar;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import com.rjconsultores.ventaboletos.dao.CategoriaRutaDAO;
import com.rjconsultores.ventaboletos.entidad.CategoriaCtrl;
import com.rjconsultores.ventaboletos.entidad.CategoriaRuta;
import com.rjconsultores.ventaboletos.service.CategoriaRutaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;

/**
 *
 * @author Wallace
 */
@Service("categoriaRutaService")
public class CategoriaRutaServiceImpl implements CategoriaRutaService {

    @Autowired
    private CategoriaRutaDAO categoriaRutaDAO;

    public List< CategoriaRuta> obtenerTodos() {
        return categoriaRutaDAO.obtenerTodos();
    }

    public CategoriaRuta obtenerID(Integer id) {
        return categoriaRutaDAO.obtenerID(id);
    }

    @Transactional
    public  CategoriaRuta suscribir( CategoriaRuta entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return categoriaRutaDAO.suscribir(entidad);
    }

    @Transactional
    public  CategoriaRuta actualizacion( CategoriaRuta entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return categoriaRutaDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar( CategoriaRuta entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);


        categoriaRutaDAO.actualizacion(entidad);
    }

    public  CategoriaRuta busquedaPoCategoriaCtrl(CategoriaCtrl categoriaCtrl) {
        return categoriaRutaDAO.busquedaPorCategoriaCtrl(categoriaCtrl);
    }
    
    @Override
	@Transactional
	public void actualizacionAuditagem(List<CategoriaRuta> lsCategoriaClase) {
		for ( CategoriaRuta cc : lsCategoriaClase) {
			if(Boolean.TRUE.equals(cc.getActivo())) {
				continue;
			}
			categoriaRutaDAO.actualizacion(cc);
		}		
	}
}
